/*
 * This file is generated by jOOQ.
 */
package de.ship.pia.emailcollector.jooq.tables;


import de.ship.pia.emailcollector.jooq.Keys;
import de.ship.pia.emailcollector.jooq.Public;
import de.ship.pia.emailcollector.jooq.tables.records.TPersonRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.List;
import java.util.function.Function;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Function7;
import org.jooq.Identity;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Records;
import org.jooq.Row7;
import org.jooq.Schema;
import org.jooq.SelectField;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TPerson extends TableImpl<TPersonRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>public.t_person</code>
     */
    public static final TPerson T_PERSON = new TPerson();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TPersonRecord> getRecordType() {
        return TPersonRecord.class;
    }

    /**
     * The column <code>public.t_person.pk</code>.
     */
    public final TableField<TPersonRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>public.t_person.pseudo_id</code>.
     */
    public final TableField<TPersonRecord, String> PSEUDO_ID = createField(DSL.name("pseudo_id"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>public.t_person.email</code>.
     */
    public final TableField<TPersonRecord, String> EMAIL = createField(DSL.name("email"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.t_person.lastchange</code>.
     */
    public final TableField<TPersonRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6), this, "");

    /**
     * The column <code>public.t_person.registered</code>.
     */
    public final TableField<TPersonRecord, Boolean> REGISTERED = createField(DSL.name("registered"), SQLDataType.BOOLEAN.nullable(false).defaultValue(DSL.field("false", SQLDataType.BOOLEAN)), this, "");

    /**
     * The column <code>public.t_person.consent_pia</code>.
     */
    public final TableField<TPersonRecord, LocalDateTime> CONSENT_PIA = createField(DSL.name("consent_pia"), SQLDataType.LOCALDATETIME(6), this, "");

    /**
     * The column <code>public.t_person.consent_ship</code>.
     */
    public final TableField<TPersonRecord, LocalDateTime> CONSENT_SHIP = createField(DSL.name("consent_ship"), SQLDataType.LOCALDATETIME(6), this, "");

    private TPerson(Name alias, Table<TPersonRecord> aliased) {
        this(alias, aliased, null);
    }

    private TPerson(Name alias, Table<TPersonRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table());
    }

    /**
     * Create an aliased <code>public.t_person</code> table reference
     */
    public TPerson(String alias) {
        this(DSL.name(alias), T_PERSON);
    }

    /**
     * Create an aliased <code>public.t_person</code> table reference
     */
    public TPerson(Name alias) {
        this(alias, T_PERSON);
    }

    /**
     * Create a <code>public.t_person</code> table reference
     */
    public TPerson() {
        this(DSL.name("t_person"), null);
    }

    public <O extends Record> TPerson(Table<O> child, ForeignKey<O, TPersonRecord> key) {
        super(child, key, T_PERSON);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Public.PUBLIC;
    }

    @Override
    public Identity<TPersonRecord, Integer> getIdentity() {
        return (Identity<TPersonRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TPersonRecord> getPrimaryKey() {
        return Keys.T_PERSON_PKEY;
    }

    @Override
    public List<UniqueKey<TPersonRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.T_PERSON_PSEUDO_ID_KEY);
    }

    @Override
    public TPerson as(String alias) {
        return new TPerson(DSL.name(alias), this);
    }

    @Override
    public TPerson as(Name alias) {
        return new TPerson(alias, this);
    }

    @Override
    public TPerson as(Table<?> alias) {
        return new TPerson(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TPerson rename(String name) {
        return new TPerson(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TPerson rename(Name name) {
        return new TPerson(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TPerson rename(Table<?> name) {
        return new TPerson(name.getQualifiedName(), null);
    }

    // -------------------------------------------------------------------------
    // Row7 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row7<Integer, String, String, LocalDateTime, Boolean, LocalDateTime, LocalDateTime> fieldsRow() {
        return (Row7) super.fieldsRow();
    }

    /**
     * Convenience mapping calling {@link SelectField#convertFrom(Function)}.
     */
    public <U> SelectField<U> mapping(Function7<? super Integer, ? super String, ? super String, ? super LocalDateTime, ? super Boolean, ? super LocalDateTime, ? super LocalDateTime, ? extends U> from) {
        return convertFrom(Records.mapping(from));
    }

    /**
     * Convenience mapping calling {@link SelectField#convertFrom(Class,
     * Function)}.
     */
    public <U> SelectField<U> mapping(Class<U> toType, Function7<? super Integer, ? super String, ? super String, ? super LocalDateTime, ? super Boolean, ? super LocalDateTime, ? super LocalDateTime, ? extends U> from) {
        return convertFrom(toType, Records.mapping(from));
    }
}
